<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, inject } from 'vue';
import Modal from '@/components/general/Modal.vue';
import PasswordField from '@/components/general/form/PasswordField.vue';
import { request } from '@/lib/request';

const password = ref('');
const passwordValid = ref(true);
const passwordConfirm = ref('');
const passwordConfirmValid = ref(true);
const configuration = inject<any>('configuration');
const showError = ref(false);

const emits = defineEmits<{
    (e: 'close'):void 
}>();

const cancel = ()=>{
    emits('close');
}

const submit = async ()=>{
    if(password.value && passwordConfirm.value && passwordValid.value && passwordConfirmValid.value && password.value === passwordConfirm.value){
        let response = await request('POST', configuration.apiServer + '/api/account/password-reset',
            { adminPassword:password.value, adminPasswordConfirm: passwordConfirm.value }, 'application/json', false, true);
        if(response && response.success){
            cancel();
        }else{
            showError.value = true;
        }
    }
}

</script>
<template>
<Modal :header="$t('general.variables.password.sg') + ' ' + $t('general.variables.change')" :labelCancel="$t('general.buttons.cancel')" 
    :labelSubmit="$t('general.buttons.send')" 
    :disableSubmit="!(password.length>=8 && passwordConfirm.length>=8 && passwordValid && passwordConfirmValid && password === passwordConfirm)"
    @submit="submit" @cancel="cancel">
    <p class="text-red-700 mb-2" v-if="showError">{{$t('adminMenu.passwordReset.error.general')}}</p>
    <PasswordField v-model="password" v-model:valid="passwordValid" :strong="true" :errorText="$t('adminMenu.passwordReset.error.password.strong')" :label="$t('general.variables.password.sg')" />
    <PasswordField v-model="passwordConfirm" v-model:valid="passwordConfirmValid" :strong="true" :errorText="$t('adminMenu.passwordReset.error.password.strong')" :label="$t('general.variables.password.sg') + ' ' + $t('general.variables.confirm')"/>
</Modal>
</template>